package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.compat.AdventureJEIPlugin;
import java.util.IdentityHashMap;
import java.util.Map;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.gui.ingredient.IRecipeSlotsView;
import mezz.jei.api.helpers.IGuiHelper;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.RecipeType;
import mezz.jei.api.recipe.category.IRecipeCategory;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.SmithingRecipe;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.block.Blocks;

public class ApothSmithingCategory implements IRecipeCategory<SmithingRecipe> {
  public static final ResourceLocation RECIPE_GUI_VANILLA = new ResourceLocation("jei", "textures/gui/gui_vanilla.png");
  
  private static final Map<Class<? extends SmithingRecipe>, Extension<SmithingRecipe>> EXTENSIONS = new IdentityHashMap<>();
  
  private final Component title = (Component)Component.m_237115_("title.apotheosis.smithing");
  
  private final IDrawable background;
  
  private final IDrawable icon;
  
  public ApothSmithingCategory(IGuiHelper guiHelper) {
    this.background = (IDrawable)guiHelper.drawableBuilder(RECIPE_GUI_VANILLA, 0, 168, 125, 18).addPadding(0, 16, 0, 0).build();
    this.icon = guiHelper.createDrawableIngredient((IIngredientType)VanillaTypes.ITEM_STACK, new ItemStack((ItemLike)Blocks.f_50625_));
  }
  
  public RecipeType<SmithingRecipe> getRecipeType() {
    return AdventureJEIPlugin.APO_SMITHING;
  }
  
  public Component getTitle() {
    return this.title;
  }
  
  public IDrawable getBackground() {
    return this.background;
  }
  
  public IDrawable getIcon() {
    return this.icon;
  }
  
  public void draw(SmithingRecipe recipe, IRecipeSlotsView recipeSlotsView, GuiGraphics gfx, double mouseX, double mouseY) {
    ((Extension)EXTENSIONS.get(recipe.getClass())).draw(recipe, recipeSlotsView, gfx, mouseX, mouseY);
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, SmithingRecipe recipe, IFocusGroup focuses) {
    ((Extension)EXTENSIONS.get(recipe.getClass())).setRecipe(builder, recipe, focuses);
  }
  
  public boolean isHandled(SmithingRecipe recipe) {
    return EXTENSIONS.containsKey(recipe.getClass());
  }
  
  public static <R extends SmithingRecipe> void registerExtension(Class<R> clazz, Extension<R> ext) {
    EXTENSIONS.put(clazz, ext);
  }
}
